// Copyright 1994 by Jon Dart.  All Rights Reserved.
#ifndef _SEARCH_LIMIT_OPTIONS_H
#define _SEARCH_LIMIT_OPTIONS_H

#include <wpp.h>
#include <wpdlg.h>
#include "types.h"
#include "timectrl.h"

struct Search_Limit_Options
{
   // holds state of the dialog
   Search_Limit_Options();
   Search_Limit_Options( const Time_Control &tc, const Control c );

   Boolean parse( Time_Control &tc, const Control c );
   
   int search_type;
   char move_or_ply[20];
   char time_limit[20];
};

class SearchLimitDialog : public WPDialogModal
{
    // handles the Search Limit ... dialog box in the Options menu.

public:

    SearchLimitDialog(WPWin *pwin, Search_Limit_Options *primary_options,
	    Search_Limit_Options *secondary_options);
    
    // override WPDlg virtual functions:
    void initDlg();
    
    BOOL command( int id, WORD msg );
    
private:
    void new_type(int srctype);
    HWND hMinutes_field, hMinutes_text, hSecondary;
    HWND hPly_text;
    static WPControlMap ControlMap[];
    int initial_search_type;
    Search_Limit_Options *secondary_options;
};

#endif